import * as Constants from './constants'
export class Length {
  value
  unit

  constructor(val, uint) {
    this.value = val
    this.unit = uint
  }

  getVal() {
    return this.value
  }  

  getUint() {
    return this.unit
  }
  parseTo(unitNode) {
    let unitLength = this
    if (this.unit === Constants.Constants.YARD) {
      if (unitNode === Constants.Constants.FOOT) {
        unitLength = new Length(this.multipleValue(3), unitNode)
      } else if (unitNode === Constants.Constants.INCH) {
        unitLength = new Length(this.multipleValue(36), unitNode)
      }
    }

    if (this.unit === Constants.Constants.INCH) {
      if (unitNode === Constants.Constants.YARD) {
        unitLength = new Length(this.divisionValue(36), unitNode)
      } else if (unitNode === Constants.Constants.FOOT) {
        unitLength = new Length(this.value / 12, unitNode)
      }
    }

    if (this.unit === Constants.Constants.FOOT) {
      if (unitNode === Constants.Constants.YARD) {
        unitLength = new Length(this.divisionValue(3), unitNode)
      } else if (unitNode === Constants.Constants.INCH) {
        unitLength = new Length(this.multipleValue(12), unitNode)
      }
    }

    return unitLength
  }

  divisionValue(conversion_Target_Unit_Value) {
    return this.value / conversion_Target_Unit_Value
  }

  multipleValue(conversion_Target_Unit_Value) {
    return this.value * conversion_Target_Unit_Value
  }
}
